include \masm32\include\masm32rt.inc

sync = 1	; [url=http://www.masm32.com/board/index.php?topic=13478.msg105421#msg105421]MichaelW[/url]: Synchronizing with the tick count at the start of the timed period will cut the uncertainty in half

Timer MACRO arg
  push ecx	; save some regs
  push edx
  invoke GetTickCount
  ifidni <arg>, <start>
	.if 1
		if sync
		push eax
		.Repeat
			invoke GetTickCount
			inc gtcloops
		.Until eax!=[esp]
		pop edx		; don't trash eax
		endif
		pop edx
		pop ecx
		push eax
		EXITM <>		;; return an empty string for Timer(start)
  else
		pop edx
		pop ecx
		pop edx			;; get the value of Timer(start)
		sub eax, edx	;; return elapsed milliseconds
	.endif
	EXITM <eax>
  endif
ENDM

.data?
globdiff	dd ?
gtcloops	dd ?

.code
start:	mov ebx, 20
	.Repeat
		imul esi, ebx, 10		; esi=ebx*10
		Timer(start)
		invoke Sleep, esi
		mov edi, Timer(end)
		print str$(edi), 9, " expected: "
		print str$(esi), ", abs(diff)="
		sub edi, esi
		.if Sign?
			neg edi
		.endif
		add globdiff, edi
		print str$(edi), 13, 10
		dec ebx
	.Until Zero?
	print "Overall difference: "
	print str$(globdiff), 13, 10, "wait loops: "
	print str$(gtcloops)
	getkey
	exit

end start

OPT_Assembler	JWAsm
OPT_Wait	0
OPT_Tmp2Asm	1
